;; (c) 1999 M. Feldt <mfeldt@mpia-hd.mpg.de>
FUNCTION vs_MakeBlist, NumBlines, BaseLine, lab_TPs
BlinesDescr = strarr(NumBlines)
FOR i = 0, NumBlines-1 DO BEGIN
    BlinesDescr[i] = lab_TPs[BaseLine[0, i]] + $
      ' -- ' + $
      lab_TPs[BaseLine[1, i]] + $
      ' Col: ' +$
      string(format = '(i3.3)', BaseLine[2, i])
ENDFOR
return, BlinesDescr
END 

PRO vs_baseselect_event, Event
  widget_control, Event.Top, get_uval = state, /No_copy
  lab_TPs = state.lab_TPs       ;historical...
  CASE Event.ID OF 
      state.Dismiss: BEGIN             ;End Gui
          widget_control, Event.Top, /clear_events, /destroy
          return
      END
      state.Apply: BEGIN
          PseudoEvent = {BLINE_EVENT, $
                         ID:state.NotifyID[0], $
                         Top:state.NotifyID[1], $
                         Handler:0l, $
                         Baseline:ptr_new(*state.BaseLine), $
                         NumBlines:state.NumBlines }
                          
          IF Widget_Info(state.NotifyID[0], /Valid_ID) THEN $
            widget_control, state.NotifyID[0], Send_Event = PseudoEvent
          widget_control, state.Apply, sens = 0
      END
      state.List: BEGIN           ;New item selected
          state.ListIndex = Event.INDEX ;update index
          CurrentBaseLine = *state.BaseLine ;extract baseline array
          widget_control, state.Del, sens = 1 ;make delete button sensitive
          widget_control, state.Edit, sens = 1 ; and also the edit functions
          widget_control, state.New, sens = 1 ;enable copying 
                                ;now update the edit controls
          widget_control, state.TP1, set_drop = CurrentBaseline[0, state.ListIndex]
          widget_control, state.TP2, set_drop = CurrentBaseline[1, state.ListIndex]
      END

      state.Del:BEGIN
                                ;delete the selected element from the list if possible
          IF state.NumBLines EQ 1 THEN BEGIN
              dummy = dialog_message('ERROR: Last Baseline cannot be deleted!', $
                                     /error)
          ENDIF ELSE BEGIN
                                ;remove selected element
              CurrentBaseLine = *state.BaseLine
              IF state.ListIndex EQ 0 THEN $
                *state.Baseline = CurrentBaseLine[*, $
                                                  1:state.NumBLines-1] $
              ELSE IF state.ListIndex EQ state.NumBLines-1 THEN $
                *state.Baseline = CurrentBaseLine[*, $
                                                  0:state.NumBlines-2] $
              ELSE $
                *state.BaseLine = CurrentBaseLine[*, $
                                                  [findgen(state.ListIndex), $
                                                   findgen(state.NumBLines-$
                                                           state.ListIndex-1) + $
                                                  state.ListIndex+1]]
                                ;reduce counter of baselines
              state.NumBLines = state.NumBlines-1
              CurrentBaseLine = *state.BaseLine
                                ;set new listindex
              state.ListIndex = (state.ListIndex-1) > 0
                                ;re-arrange controls
              widget_control, state.TP1, set_drop = CurrentBaseLine[0, state.ListIndex]
              widget_control, state.TP2, set_drop = CurrentBaseLine[1, state.ListIndex]
              widget_control, state.List, set_val = vs_MakeBlist(state.NumBlines, $
                                                                      *state.BaseLine, $
                                                                      lab_TPs)
              widget_control, state.List, set_list_sel = state.ListIndex
              widget_control, state.Apply, sens = 1
          ENDELSE 
      END
      state.New:BEGIN
          state.NumBLines = state.NumBLines+1
          CurrentBaseLine = *state.BaseLine
          *state.BaseLine = [[CurrentBaseLine], $
                             [CurrentBaseLine[*, state.ListIndex]]]
          ;; add selected element at the end
          state.ListIndex = state.NumBLines-1 ;select new element
          ;; update list widget
          CurrentBaseLine = *state.BaseLine
          widget_control, state.List, set_val =  vs_MakeBlist(state.NumBlines, $
                                                                   *state.BaseLine, $
                                                                   lab_TPs)
          widget_control, state.List, set_list_sel = state.NumBLines-1
          ;; re-arrange controls
          widget_control, state.TP1, set_drop = CurrentBaseLine[0, state.ListIndex]
          widget_control, state.TP2, set_drop = CurrentBaseLine[1, state.ListIndex]
          widget_control, state.Apply, sens = 1
      END
      state.TP1:BEGIN
          CurrentBaseLine = *state.BaseLine ;extract baseline variable
          NTP1 = widget_info(state.TP1, /Droplist_Select) ;extract new telescope one
          CurrentBaseLine[0, state.ListIndex] = NTP1 ;change corresponding value
          *state.BaseLine = CurrentBaseLine ;update parent variabe
          widget_control, state.List, set_val = vs_MakeBlist(state.NumBlines, $
                                                                  *state.BaseLine, $
                                                                  lab_TPs)
          widget_control, state.List, set_list_sel = state.ListIndex ;re-set selected
          widget_control, state.Apply, sens = 1
      END
      state.TP2:BEGIN
          CurrentBaseLine = *state.BaseLine ;extract baseline variable
          NTP2 = widget_info(state.TP2, /Droplist_Select) ;extract new telescope one
          CurrentBaseLine[1, state.ListIndex] = NTP2 ;change corresponding value
          *state.BaseLine = CurrentBaseLine ;update parent variabe
          widget_control, state.List, set_val = vs_MakeBlist(state.NumBlines, $
                                                                  *state.BaseLine, $
                                                                  lab_TPs)
          widget_control, state.List, set_list_sel = state.ListIndex ;re-set selected
          widget_control, state.Apply, sens = 1
      END
  ENDCASE

widget_control, Event.top, set_uval = state, /No_Copy
END 




PRO vs_BaseSelect, lab_TPs, NotifyID, numblines, baseline, parent=parent
COMMON vs_block

IF NOT Xregistered('vs_baseselect')  THEN BEGIN 
    BlinesDescr = strarr(6)
    
; Labels for widgets
    
    lab_del = 'Delete'
    lab_apply = 'Apply'
    lab_new = 'Add'
    lab_dismiss = 'Dismiss'
    lab_panel = 'Baseline Setup'
    lab_tel1 = 'Telescope 1'
    lab_tel2 = 'Telescope 2'
    
    ;;this should become a procedure argument once the 
    ;;package is ready
;    lab_TPs = ['UT1', 'UT2', 'UT3', 'UT4']
                                

    ;; Make baseline editor widget

  BaseBASE = widget_base(title = lab_panel, /Col, /Base_Align_Center)
  BaseEDIT = widget_base(BaseBASE, /frame, col = 2)
  BaseLAB1 = widget_label(BaseEDIT, val = lab_tel1, font=vs_fonts[1])
  BaseTP1 = widget_droplist(BaseEDIT, val = lab_TPs, font=vs_fonts[1])
  BaseLAB2 = widget_label(BaseEDIT, val = lab_tel2, font=vs_fonts[1])
  BaseTP2 = widget_droplist(BaseEDIT, val = lab_TPs, font=vs_fonts[1])
  ;;
  BaseCONTR = widget_base(BaseBASE, col = 4)
  BaseNEW = widget_button(BaseCONTR, val = lab_new, font=vs_fonts[1])
  BaseDEL = widget_button(BaseCONTR, val = lab_del, font=vs_fonts[1])
  BaseAPPLY = widget_button(BaseCONTR, val = lab_apply, font=vs_fonts[1])
  BaseDISMISS = Widget_button(BaseCONTR, val = lab_dismiss, font=vs_fonts[1])
  BaseLIST = widget_list(BaseBASE, val = '', $
                         xsize = 20, $
                         ysize = 30, $
                         font=vs_fonts[2])

; Initialize the GUI
  widget_control, BaseEDIT, sens = 0
  widget_control, BaseLIST, set_val = vs_MakeBlist(NumBlines, $
                                                   BaseLine, $
                                                   lab_TPs $
                                                   )
  widget_control, BaseDEL, sens = 0
  widget_control, BaseNEW, sens = 0
  widget_control, BaseAPPLY, sens = 0
  widget_control, BaseBASE, /realize
  BaseState = {lab_TPs:lab_TPs, $
               NotifyID:NotifyID, $
               NumBlines:NumBlines, $
               BaseLine:ptr_new(BaseLine), $
               Edit:BaseEDIT, $
               TP1:BaseTP1, $
               TP2:BaseTP2, $
               New:BaseNew, $
               Del:BaseDEL, $
               Apply:BaseAPPLY, $
               Dismiss:BaseDISMISS, $
               List:BaseLIST, $
               ListIndex:0 $
              }
  widget_control, BaseTP1, set_uval = BaseState

  widget_control, BaseBASE, set_uval = BaseState, /No_Copy
  xmanager, 'vs_baseselect', BaseBASE, /no_block, Group_Leader=parent
ENDIF 
END
