PRO vs_manage_colors, STATE = state
   ;;
   ;;
   ;;
   COMMON CCOLOR, xcolors

   xcolors = {                     $
               vistype: '',          $
               ncolors: 0,           $
               top:     0,           $
               bottom:  0,           $
               r:       BYTARR(256), $
               b:       BYTARR(256), $
               g:       BYTARR(256)  $
             }

   ;; Is this a 24-bit TrueColor device? If so,
   ;; make it an 8-bit display for convenience...

   IF !version.release GE 5.1 THEN BEGIN
      DEVICE, Get_Visual_Name=vistype
      IF vistype EQ 'TrueColor' OR vistype EQ 'DirectColor' THEN BEGIN
          Device, decomposed=0
          IF  (!Version.OS_FAMILY ne 'Windows') THEN $
            device, pseudo_color=8 
      ENDIF
   ENDIF ELSE BEGIN
      DEVICE, Decomposed=0
   ENDELSE
   ;; set default color table (rainbow)
   LOADCT, 13, /SILENT & state.color_tbl = 13

   xcolors.ncolors = !D.Table_Size
   xcolors.bottom = 0
   xcolors.top = xcolors.ncolors +xcolors.bottom - 1

   ;; get the colors that make up the current colour table
   TVLCT, rr, gg, bb, /Get
   xcolors.r = rr(xcolors.bottom:xcolors.top)
   xcolors.g = gg(xcolors.bottom:xcolors.top)
   xcolors.b = bb(xcolors.bottom:xcolors.top)
END


PRO vs_panel_event, Event
  COMMON vs_block, vs_path, vs_debug, vs_fonts, vs_wid, vs_wwid, vs_dispsize, $
    vs_midicontrol, vs_ambercontrol, vs_list_id, vs_midivis_id, $
    vs_midihh_id, vs_midiuv_id, vs_midiim_id, vs_telescopes, vs_SCRDevice, $
    vs_FileExport, vs_FilePrint
  ;;
  lab_TPs = ['UT1', 'UT2', 'UT3', 'UT4']
  vs_telescopes = ['UT1', 'UT2', 'UT3', 'UT4']
  widget_control, Event.Top, get_uval=state, /No_Copy
  widget_control, Event.ID, get_uval=Index
  IF vs_debug THEN print, Index
  CASE Index OF
      'FileSave':BEGIN
          SaveFileName = dialog_pickfile(/write, $
                                        filter='*.vsf', $
                                        /fix $
                                        )
          IF strmid(SaveFileName, strlen(SaveFileName-4), 4) NE '.vsf' THEN $
            SaveFileName=SaveFileName+'.vsf'
          IF SaveFileName NE '' THEN $
              save, state, file=SaveFileName
      END
      'FileLoad':BEGIN
          LoadFileName = dialog_pickfile(/read, $
                                         /must, $
                                         filter='*.vsf', $
                                         /fix $
                                        )
          IF LoadFileName NE ''THEN BEGIN
              restore, LoadFileName
              vs_update_state, state
              IF state.ComputationDone THEN $
                vs_midiplotsetup, state
          ENDIF
      END
      'FileQuit':BEGIN
          Answer = Dialog_Message('Really Quit?', /Question)
          IF Answer EQ 'Yes' THEN BEGIN
              widget_control, Event.Top, /Clear_Events, /Destroy
              return
          ENDIF
      END
      'ConfigCol':BEGIN
          EventName = tag_names(Event, /Structure_Name)
          IF EventName EQ 'XCOLORS_LOAD' THEN BEGIN
              IF Event.Index NE -1 THEN $
                state.Color_TBL=Event.Index
          ENDIF ELSE BEGIN
              xcolors, $
                Group=Event.Top, $
                NotifyID=[Event.ID, Event.Top]
          ENDELSE
      END
      'ConfigDebugSwitch':BEGIN
          vs_debug = 1-vs_debug
          widget_control, Event.ID, set_val=(['Turn On', 'Turn Off'])[vs_debug]
      END
      'ConfigDebugBreak':stop
      'HelpIFM':vs_xhelp, 'BASELINES', Parent=Event.Top
      'HelpAbout':vs_xhelp, 'ABOUT', Parent=Event.Top
      'HelpTodo':vs_xhelp, 'TODO', Parent=Event.Top
      'HelpLicense':vs_xhelp, 'LICENSE', Parent=Event.Top
      'HelpMapM':vs_xhelp, 'MAPMAKER', Parent=Event.Top
      'ButtIfmtr':BEGIN
          EventName = tag_names(Event, /Structure_Name)
          IF EventName EQ 'BLINE_EVENT' THEN BEGIN
              state.NumBlines = Event.NumBlines
              *state.Baseline = *Event.Baseline
              *state.BaseSelect = -1
          ENDIF ELSE BEGIN
              nb = state.NumBlines
              bl = *state.BaseLine
              vs_baseselect, lab_TPs, [Event.ID, Event.Top], nb, bl
          ENDELSE
      END
      'ButtSource':BEGIN
          EventName = tag_names(Event, /Structure_Name)
          IF EventName EQ 'TARGETEVENT' THEN BEGIN
              state.InFile = Event.FileName
              state.ObjDec = Event.ObjDec
          ENDIF ELSE BEGIN
              vs_target, [Event.ID, Event.Top], state
          ENDELSE
      END
      'ButtInstr':BEGIN
          EventName = tag_names(Event, /Structure_Name)
          CASE EventName OF
              'INSTRUMENT_EVENT':BEGIN
                  state.FilterW = Event.FilterW
                  state.StartHr = Event.StartHr
                  state.EndHr = Event.EndHr
                  state.Rot = Event.Rot
                  state.DIT = Event.DIT
                  state.NDIT = Event.NDIT
                  *(state.ObsTimes) = *(Event.ObsTimes)
              END
              ELSE:BEGIN
                  vs_instrument, [Event.ID, Event.Top], state
              END
          ENDCASE
      END
      'ButtRun':BEGIN
          IF state.Instrument EQ 'MIDI' THEN BEGIN
              vs_simmidi, state
              state.PlotOption = 0 ;indicate a new computation for plotsetup
              vs_midiplotsetup, state
          ENDIF ELSE BEGIN
          ENDELSE
      END
      'PlotFrameSelect':BEGIN
          state.SelFrame = Event.Index
          Widget_Control, Event.ID, /Clear_Events
          vs_midiplotsetup, state
      END
      'MidiErrb': BEGIN
          state.ErrbSize = vs_errbselect(state)
          vs_midiplotsetup, state
      END
      'MidiBLC':BEGIN
          vs_baseplotselect, state
          vs_midiplotsetup, state
      END
      'MidiImCuts':BEGIN
          vs_dispcuts, state
          vs_midiplotsetup, state
      END
      'MidiUVCuts':BEGIN
          vs_dispcuts, state, /visibility
          vs_midiplotsetup, state
      END
      'MidiPlotVisNu':BEGIN
          state.PlotOption = 1
          vs_midiplotsetup, state
      END
      'MidiPlotHNu':BEGIN
          state.PlotOption = 2
          vs_midiplotsetup, state
      END
      'MidiPlotUV':BEGIN
          state.PlotOption = 3
          vs_midiplotsetup, state
      END
      'MidiPlotIm':BEGIN
          state.PlotOption = 4
          vs_midiplotsetup, state
      END
      'MidiUVread':BEGIN
          vs_readval, state
      END
      'MidiImRead':BEGIN
          vs_readval, state, /image
      END
      'MidiPrint':BEGIN
          vs_print, state
      END
      'MidiExport':BEGIN
          vs_midiexport, state
      END
      ELSE:
  ENDCASE
  IF vs_debug THEN print, state
  IF n_elements(EventName) NE 0 THEN BEGIN
      IF (where(Eventname[0] EQ ['INSTRUMENT_EVENT', 'TARGETEVENT', 'BLINE_EVENT']))[0] NE -1 THEN BEGIN
          ;; if any input parameter is re-set,  deactivate plotting
          ;; controls and erase window
          Widget_Control, vs_midicontrol,  sens=0
          Widget_Control, vs_ambercontrol,  sens=0
          Widget_Control, vs_FileExport,  sens=0
          Widget_Control, vs_FilePrint,  sens=0
          vs_showlogo, 'vlti.gif'
          Widget_Control, vs_list_id, sens=0, set_val=''
          state.ComputationDone = 0
      ENDIF
  ENDIF
  widget_control, Event.top, set_uval=state, /No_Copy
END


PRO vs_panel
  COMMON vs_block
  forward_FUNCTION vs_manage_colors
  ;;
  ;; initialize values
  ;; Turn on debugging first
  vs_debug = 1
  ;window, 1, xsize = 1, ysize = 1, col = 256
  ;wdelete, 1
  ;;
  ;; Determine the installation path
  IF  !VERSION.OS_FAMILY EQ 'MacOS' THEN begin
  	PathSep = ','
  	vs_SCRDevice='MAC'
  endif
  IF  !VERSION.OS_FAMILY EQ 'unix' THEN begin
  	PathSep = ':'
  	vs_SCRDevice='X'
  endif
  IF  !VERSION.OS_FAMILY EQ 'Windows' THEN begin
  	PathSep = ';'
  	vs_SCRDevice='WIN'
  endif
  cd, current=CurDir
  path = CurDir+PathSep + !path
  while strlen(path) gt 0 do begin ; Find it
      i = strpos(path, PathSep)
      if i lt 0 then i = strlen(path)
      file = filepath('vs_panel.pro',root=strmid(path, 0, i))
      ffile = findfile(file, count=cf)
      if cf gt 0 then begin
          vs_path = strmid(path, 0, i)
          path = ''
      ENDIF ELSE $
        path=strmid(path, i+1, strlen(path))
  ENDWHILE
  if cf eq 0 then message, 'You should not come here ...'
  !path = !path+PathSep+expand_path('+'+vs_path)
  ;;
  ;; Set GUI properties
  ;;
  device, get_screen_size=Ssize

  IF Ssize[0] GT 1000 THEN BEGIN
      DispSize = 512
      device, get_fontnames=tt, font='*helvetica-bold-r-normal--18*'
      ButFont = tt[0]
      device, get_fontnames=tt, font='*helvetica-bold-r-normal--12*'
      ButFontSmall = tt[0]
      device, get_fontnames=tt, font='*helvetica-medium-r-normal--12*'
      ButFontSub = tt[0]
  ENDIF ELSE BEGIN
      DispSize = 384

      device, get_fontnames=tt, font='*helvetica-bold-r-normal--14*'
      ButFont = tt[0]
      device, get_fontnames=tt, font='*helvetica-bold-r-normal--10*'
      ButFontSmall = tt[0]
      device, get_fontnames=tt, font='*helvetica-medium-r-normal--10*'
      ButFontSub = tt[0]
  ENDELSE
  vs_dispsize = DispSize
  ;;
  ;;
  VS_Fonts = [ButFont, ButFontSmall, ButFontSub]
  ;;
  ;; Make state variable to hold everything...
  ;;
  state = {version:[0, 30, 0], $
           color_tbl:0, $
           InFile:filepath('example.fits',root=vs_path), $
           NumBlines: 1, $
           BaseLine: ptr_new([0, 1, !D.Table_Size/2]), $
           Instrument:'MIDI', $
           FilterW:0.4, $
           ObjDec:-30.0, $
           StartHr: -2.0, $
           EndHr: 2.0, $
           Rot:0.0, $           ;Artificial image rotation
           DIT:0.025, $         ;base integration time
           NDIT:1000., $        ;number of integrations per observation
           UseTrack:ptr_new(), $  ;Use external fringe tracker (no)?
           ObsTimes:ptr_new([0.0]), $ ;will hold the vector of observing times
           ComputationDone:0, $ ;Not Yet...
           Result:ptr_new(), $  ;Holds result of simulations
           SelFrame:0, $        ;Which Frame is selected for display
           BaseSelect:ptr_new(-1), $ ;Which baselines are ectually displayed
           PlotOption:0, $      ; 0=no plot active,1-4 kind of plot (MIDI)
           ErrbSize:0.0, $      ; show errorbars (0=no,>0=absolute, <0=calculate real)
           DispCutLow:0.1, $    ; Display cuts for images
           DispCutHigh:0.99, $
           DispScale:'log', $   ; be 'log', 'lin' or 'sqrt'
           VisCutLow:0.1, $
           VisCutHigh:0.99, $
           VisScale:'log', $
           ExportFile:'SimVLTI.dat', $
           PrintFile:'SimVLTI.ps' $
          }
  ;;
  vs_manage_colors, state=state
  IF !d.Window NE -1 THEN wdelete
  ;;
  ;; Init labels for GUI
  ;;
  lab_about = 'About'
  lab_amber = 'AMBER'
  lab_blc = 'Baselines..'
  lab_break = 'Break'
  lab_col = 'Colour Table'
  lab_conf = 'Config'
  lab_cuts = 'Cuts..'
  lab_debug = 'Debugging'
  lab_debug_state = ['Turn on',  'Turn off']
  lab_errb = 'Error Bars..'
  lab_exp = 'Export ASCII..'
  lab_file = 'File'
  lab_help = 'SimVLTI Help'
  lab_hnu = 'Time-Vis. Plot'
  lab_im = 'Show Image'
  lab_instr = 'Instrument'
  lab_license = 'License'
  lab_load = 'Open Session..'
  lab_midi = 'MIDI'
  lab_print = 'Print..'
  lab_quit = 'Quit'
  lab_read = 'Read Values..'
  lab_save = 'Save session..'
  lab_todo = 'ToDo'
  lab_uv = 'UV-Plane Plot'
  lab_visnu = 'Freq.-Vis. Plot'
  ;;
  ;;
  lab_on_ifmeter = 'On Baselines'
  lab_on_mapm = 'On Input Maps'
  lab_on_instr = 'On Instrument'
  lab_on_midi = 'On MIDI result'
  ;;
  ;;
  lab_set_ifmtr = 'Baselines Setup..'
  lab_set_instr = 'Instrument Setup..'
  lab_set_source = 'Target Setup..'
  lab_set_run = 'Run Simulation'
  ;; Now build the GUI
  ;;
  Base = widget_base(app_mbar=Bar, Col=2)
  ;;
  ;; First the menu bar
  ;;
  ;; File
  File = widget_button(Bar, /Menu, val=lab_file, uval='File', font=ButFontSmall)
  FileLoad = widget_button(File, val=lab_load, uval='FileLoad', font=ButFontSub)
  FileSave = widget_button(File, val=lab_save, uval='FileSave', font=ButFontSub)
  FileExport = widget_button(File, val=lab_exp, uval='MidiExport', font=ButFontSub)
  FilePrint = widget_button(File, val=lab_print, uval='MidiPrint', font=ButFontSub)  
  FileQuit = widget_button(File, val=lab_quit, uval='FileQuit', font=ButFontSub)
  Widget_Control, FileExport,  sens=0
  Widget_Control, FilePrint,  sens=0
  ;; Config
  Config = widget_button(Bar, /Menu, val=lab_conf, uval='Config', font=ButFontSmall)
  ConfigInstr = widget_button(Config, /Menu, val=lab_instr, $
                              uval='ConfigInstr', font=ButFontSub)
  ConfigMIDI = widget_button(ConfigInstr, val=lab_midi, $
                             uval='ConfigMIDI', font=ButFontSub)
  ConfigAMBER = widget_button(ConfigInstr, val=lab_amber, $
                              uval='ConfigAMBER', font=ButFontSub)
  Widget_Control, ConfigAmber, sens=0
  ConfigCol = widget_button(Config, val=lab_col, $
                            uval='ConfigCol', font=ButFontSub)
  ConfigDebug = Widget_Button(Config, $
                              /Menu, $
                              val=lab_debug, $
                              font=vs_fonts[2], $
                              uval='ConfigDebug')
  ConfigDebugSwitch = Widget_button(ConfigDebug, $
                                    val=lab_debug_state[vs_debug], $
                                    font=vs_fonts[2], $
                                    uval='ConfigDebugSwitch')
  ConfigDebugBreak = Widget_Button(ConfigDebug, $
                                   val=lab_break, $
                                   font=vs_fonts[2], $
                                   uval='ConfigDebugBreak' $
                                  )
  ;;Help
  Help = widget_button(Bar, /Menu, /Help, val=lab_help, $
                       uval='Help', font=ButFontSmall)
  HelpAbout = widget_button(Help, val=lab_about, $
                            uval='HelpAbout', font=ButFontSub)
  HelpTodo = widget_button(Help, val=lab_todo, $
                           uval='HelpTodo', font=ButFontSub)
  Helplicense = widget_button(Help, val=lab_license, $
                              uval='HelpLicense', font=ButFontSub)
  HelpIFM = widget_button(Help, val=lab_on_ifmeter, $
                          uval='HelpIFM', font=ButFontSub, /sepa)
  HelpMapM = widget_button(help, val=lab_on_mapm, $
                           uval='HelpMapM', font=ButFontSub)
  ;;
  ;; Then the main body
  ;;
  BaseButtons = widget_base(Base, /col)

  IF !version.release GE 5.2 THEN BEGIN
          ButtLogo = widget_button(BaseButtons, scr_ysize=Dispsize/4, $
                                   val=filepath('simvlti_logo.bmp', root=vs_path, sub='Pixmaps'), $
                                   uval='HelpAbout', $
                                   /Bitmap)
  ENDIF ELSE BEGIN
      Read_X11_Bitmap, filepath('logo.xbm', root=vs_path, sub='Pixmaps'), LogoMap
      ButtLogo = widget_button(BaseButtons, scr_ysize=Dispsize/4, $
                               val=LogoMap, $
                               uval='HelpAbout'$
                              )
  ENDELSE
  ButtSource = widget_button(BaseButtons, $
                             scr_ysize=DispSize/4, $
                             val=lab_set_source, $
                             font=ButFont, $
                             uval='ButtSource')
  ButtIfmtr = widget_button(BaseButtons, $
                            scr_ysize=Dispsize/4, $
                            val=lab_set_ifmtr, $
                            uval='ButtIfmtr', $
                            font=ButFont)
  ButtInstr = widget_button(BaseButtons, $
                            scr_ysize=Dispsize/4, $
                            val=lab_set_instr, $
                            uval='ButtInstr', $
                            font=ButFont)
  ButtRun = widget_button(BaseButtons, $
                          scr_ysize=Dispsize/4, $
                          val=lab_set_run, $
                          uval='ButtRun', $
                          font=ButFont)
  ;;
  ;;
  BasePlot = widget_base(Base, /col, /Base_Align_Center)
  Win = widget_draw(BasePlot, $
                    xsize=DispSize, $
                    ysize=DispSize, $
                    uval='Win', $
                    colors=256, $
                   /motion)
  ;;
  ;; Make the MIDI Plot control Base
  ;;
  FrameSelect = Widget_Droplist(BasePlot, $
                                val=[''], $
                                uval='PlotFrameSelect', $
                                font=vs_fonts[1], $
                                scr_xsize=DispSize, $
                                xsize=DispSize $
                               )

  MIDI = widget_base(BasePlot, col=2, uval='BaseMIDI')
;  MidiControl = Widget_Base(MIDI, scr_xsize=DispSize/5, /col, space=0)

;  MidiPrint = Widget_Button(MidiControl, $
;                            val=lab_print, $
;                            font=vs_fonts[1], $
;                            uval='MidiPrint')
;  MidiExport = Widget_Button(MidiControl, $
;                             val=lab_exp, $
;                             font=vs_fonts[1], $
;                             uval='MidiExport')
;  MidiQuit = Widget_Button(MidiControl, $
;                           val=lab_quit, $
;                           font=vs_fonts[1], $
;                           uval='FileQuit')
  ;;
  MidiPlotSetup = Widget_Base(MIDI, /col, $
                              /Base_Align_Center, $
                              /frame, $
                              xsize=DispSize)
  ;;
  MidiTypeSelect = Widget_Base(MidiPlotSetup, col=4, space=0)
  MidiPlotVisNu = Widget_Button(MidiTypeSelect, $
                                val=lab_visnu, $
                                font=vs_fonts[1], $
                                uval='MidiPlotVisNu')
  MidiVisNuBase = Widget_Base(MidiTypeSelect, /col, space=0)
  Widget_Control, MidiVisNuBase, sens=0
  MidiPlotHNu = Widget_Button(MidiTypeSelect, $
                              val=lab_hnu, $
                              font=vs_fonts[1], $
                              uval='MidiPlotHNu')
  MidiHNuBase = Widget_Base(MidiTypeSelect, /col, space=0)
  Widget_Control,  MidiHNuBase, sens=0
  MidiPlotUV = Widget_Button(MidiTypeSelect, $
                             val=lab_uv, $
                             font=vs_fonts[1], $
                             uval='MidiPlotUV')
  MidiUVBase = Widget_Base(MidiTypeSelect, /col, space=0)
  Widget_Control, MidiUVBase, sens=0
  MidiPlotIm = Widget_Button(MidiTypeSelect, $
                             val=lab_im, $
                             font=vs_fonts[1], $
                             uval='MidiPlotIm')
  MidiImBase = Widget_Base(MidiTypeSelect, /col, space=0)
  Widget_Control, MidiImBase, sens=0
  ;;
  MidiVisNuErr = Widget_Button(MidiVisNuBase, $
                               font=vs_fonts[1], $
                               val=lab_errb, $
                               uval='MidiErrb')
  MidiVisNuBLC = Widget_Button(MidiVisNuBase, $
                               font=vs_fonts[1], $
                               val=lab_blc, $
                               uval='MidiBLC')
  MidiHNuErr = Widget_Button(MidiHNuBase, $
                             font=vs_fonts[1], $
                             val=lab_errb, $
                             uval='MidiErrb')
  MidiHNuBLC = Widget_Button(MidiHNuBase, $
                             font=vs_fonts[1], $
                             val=lab_blc, $
                             uval='MidiBLC')
  MidiUVCuts = Widget_Button(MidiUVBase, $
                             font=vs_fonts[1], $
                             val=lab_cuts, $
                             uval='MidiUVCuts')
  MidiUVBLC = Widget_Button(MidiUVBase, $
                            font=vs_fonts[1], $
                            val=lab_blc, $
                            uval='MidiBLC')
  MidiUVread = Widget_Button(MidiUVBase, $
                             font=vs_fonts[1], $
                             val=lab_read, $
                             uval='MidiUVread')
  MidiImCuts = Widget_Button(MidiImBase, $
                             font=vs_fonts[1], $
                             val=lab_cuts, $
                             uval='MidiImCuts')
  MidiImRead = Widget_Button(MidiImBase, $
                             font=vs_fonts[1], $
                             val=lab_read, $
                             uval='MidiImRead' $
                            )
  Widget_Control, MIDI, sens=0
  vs_list_ID = FrameSelect
  vs_midivis_id = MidiVisNuBase
  vs_midihh_id = MidiHNuBase
  vs_midiuv_id = MidiUVBase
  vs_midiim_id = MidiImBase
  vs_FileExport = FileExport
  vs_FilePrint = FilePrint
  ;;
  AMBER = widget_base(BasePlot, row=3, uval='BaseAMBER', map=0)
  ;;
  ;;
  vs_midicontrol = MIDI
  vs_ambercontrol = AMBER
  widget_control, base, /realize
  widget_control, Win, get_val=Wid
  Widget_Control, Win, sens=0
  vs_wid = Wid                  ;store window id in the common block
  vs_wwid = Win
  widget_control, Base, set_uval=state, /No_Copy
  xmanager, 'vs_panel', Base, /No_Block
  vs_showlogo, 'vlti.gif'
END
