PRO vs_update_state, state
  COMMON vs_block
  IF total(state.version LT [0, 30, 0]) GE 1 THEN BEGIN
      ;;
      ;; define the new state structure
      NewState = {version:[0, 30, 0], $
                  color_tbl:0, $
                  InFile:filepath('example.fits', root=vs_path), $
                  NumBlines: 1, $
                  BaseLine: ptr_new([0, 1, !D.Table_Size/2]), $
                  Instrument:'MIDI', $
                  FilterW:0.0, $
                  ObjDec:-30.0, $
                  StartHr: -2.0, $
                  EndHr: 2.0, $        
                  Rot:0.0, $    ;Artificial image rotation
                  DIT:0.025, $  ;base integration time
                  NDIT:1000., $ ;number of integrations per observation
                  UseTrack:ptr_new(), $ ;Use external fringe tracker (no)?
                  ObsTimes:ptr_new([0.0]), $ ;will hold the vector of observing times
                  ComputationDone:0, $ ;Not Yet...
                  Result:ptr_new(), $ ;Holds result of simulations
                  SelFrame:0, $ ;Which Frame is selected for display
                  BaseSelect:ptr_new(-1), $ ;Which baselines are ectually displayed
                  PlotOption:0, $ ; 0=no plot active,1-4 kind of plot (MIDI)
                  ErrbSize:0.0, $ ; show errorbars (0=no,>0=absolute, <0=calculate real)
                  DispCutLow:0.1, $ ; Display cuts for images
                  DispCutHigh:0.99, $
                  DispScale:'log', $ ; be 'log', 'lin' or 'sqrt'
                  VisCutLow:0.1, $
                  VisCutHigh:0.99, $
                  VisScale:'log', $
                  ExportFile:'SimVLTI.dat', $
                  PrintFile:'SimVLTI.ps' $
                 }
      ;; and copy all values that where there from the first version
      ;;
      NewState.color_tbl = state.color_tbl
      NewState.InFile = State.InFile
      NewState.NumBlines = State.NumBlines
      NewState.BaseLine = State.BaseLine
      NewState.Instrument = State.Instrument
      NewState.FilterW = State.FilterW 
      NewState.ObjDec = State.ObjDec
      NewState.StartHr = State.StartHr
      NewState.EndHr = State.EndHr
      NewState.Rot = State.Rot
      NewState.ComputationDone = State.ComputationDone
      NewState.Result = State.Result
      NewState.SelFrame = State.SelFrame
      NewState.BaseSelect = State.BaseSelect
      NewState.PlotOption = State.PlotOption
      NewState.ErrbSize = State.ErrbSize
      NewState.DispCutLow = State.DispCutLow 
      NewState.DispCutHigh = State.DispCutHigh
      NewState.DispScale = State.DispScale
      NewState.ExportFile = State.ExportFile
      NewState.PrintFile = State.PrintFile
      ;; now the new values...
      IF total(state.version LT [0, 30, 0]) GE 1 THEN BEGIN
          NewState.DIT = NewState.DIT
          NewState.NDIT = NewState.NDIT
          NewState.UseTrack = NewState.UseTrack
          NewState.ObsTimes = NewState.ObsTimes
      ENDIF ELSE BEGIN
          NewState.DIT = State.DIT
          NewState.NDIT = State.NDIT
          NewState.UseTrack = State.UseTrack
          NewState.UseObstimes = State.ObsTimes
      ENDELSE 

      IF total(state.version LT [0, 25, 2]) GE 1 THEN BEGIN          
          NewState.VisCutLow = NewState.DispCutLow
          NewState.VisCutHigh = NewState.DispCutHigh
          NewState.VisScale = NewState.DispScale
      ENDIF ELSE BEGIN
          NewState.VisCutLow = State.DispCutLow
          NewState.VisCutHigh = State.DispCutHigh
          NewState.VisScale = State.DispScale
      ENDELSE
      state = NewState
  ENDIF 
END 
